/*
 * T030 ROM BIOS - C runtime
 *
 * (c) 2016 Tobias Rathje <tobbe@fasanix.com>
 *
 */

extern char _rom_data;
extern char _data_start;
extern char _data_end;
extern char _bss_start;
extern char _bss_end;

extern int main();

void _start()
{
	char *src = &_rom_data;
	char *dst = &_data_start;

	// copy data from rom to ram
	while (dst < &_data_end)
	  *dst++ = *src++;

	// zero bss
	for (dst = &_bss_start; dst < &_bss_end; dst++)
	  *dst = 0;

	main();
}
