#define BI_LAST         0x0000  /* last record (sentinel) */
#define BI_MACHTYPE     0x0001  /* machine type (__be32) */
#define BI_CPUTYPE      0x0002  /* cpu type (__be32) */
#define BI_FPUTYPE      0x0003  /* fpu type (__be32) */
#define BI_MMUTYPE      0x0004  /* mmu type (__be32) */
#define BI_MEMCHUNK     0x0005  /* memory chunk address and size */
                    /* (struct mem_info) */
#define BI_RAMDISK      0x0006  /* ramdisk address and size */
                    /* (struct mem_info) */
#define BI_COMMAND_LINE     0x0007  /* kernel command line parameters */
                    /* (string) */
/*
 * bootinfo structures from asm/bootinfo.h
 * modified with standard types
 */
struct bi_record
{
	uint16_t tag; 		/* tag ID */
	uint16_t size; 		/* size of record (in bytes) */
	uint32_t data[0]; 	/* data */
};

struct mem_info
{
	uint32_t addr; 		/* physical address of memory chunk */
	uint32_t size; 		/* length of memory chunk (in bytes) */
};

uint32_t last_xfer_size;

void netload_kernel();
void load_kernel(char *cmd_line, uint32_t rd_addr, uint32_t rd_size);
