#include "util.h"

#define MFP_BASE 0x100000

#define MFPGPDR _MMIO_BYTE(MFP_BASE + 0x0)	// GPIO data register
#define MFPAER _MMIO_BYTE(MFP_BASE + 0x1)	// active edge register
#define MFPDDR _MMIO_BYTE(MFP_BASE + 0x2)	// data direction register
#define MFPIERA _MMIO_BYTE(MFP_BASE + 0x3)	// interrupt enable register A
#define MFPIERB _MMIO_BYTE(MFP_BASE + 0x4)	// interrupt enable register B
#define MFPIPRA	_MMIO_BYTE(MFP_BASE + 0x5)	// interrupt pending register A
#define MFPIPRB	_MMIO_BYTE(MFP_BASE + 0x6)	// interrupt pending register B
#define MFPISRA	_MMIO_BYTE(MFP_BASE + 0x7)	// interrupt in service register A
#define MFPISRB _MMIO_BYTE(MFP_BASE + 0x8)	// interrupt in service register B
#define MFPIMRA _MMIO_BYTE(MFP_BASE + 0x9)	// interrupt mask register A
#define MFPIMRB _MMIO_BYTE(MFP_BASE + 0xa)	// interrupt mask register B
#define MFPVR _MMIO_BYTE(MFP_BASE + 0xb)	// vector register
#define MFPTACR _MMIO_BYTE(MFP_BASE + 0xc)	// timer A control register
#define MFPTBCR _MMIO_BYTE(MFP_BASE + 0xd)	// timer B control register
#define MFPTCDCR _MMIO_BYTE(MFP_BASE + 0xe)	// timer C/D control register
#define MFPTADR _MMIO_BYTE(MFP_BASE + 0xf)	// timer A data register
#define MFPTBDR _MMIO_BYTE(MFP_BASE + 0x10)	// timer B data register
#define MFPTCDR _MMIO_BYTE(MFP_BASE + 0x11)	// timer C data register
#define MFPTDDR _MMIO_BYTE(MFP_BASE + 0x12)	// timer D data register
#define MFPSCR _MMIO_BYTE(MFP_BASE + 0x13)	// synchronous character register
#define MFPUCR _MMIO_BYTE(MFP_BASE + 0x14)	// USART control register
#define MFPRSR _MMIO_BYTE(MFP_BASE + 0x15)	// receiver status register
#define MFPTSR _MMIO_BYTE(MFP_BASE + 0x16)	// transmitter status register
#define MFPUDR _MMIO_BYTE(MFP_BASE + 0x17)	// USART data register

void mfp_init();
void mfp_putc(unsigned char c);
int mfp_getc();
int mfp_getc_buf();
void mfp_puts(char *s);
void mfp_set_uart_int(int x);
void mfp_printf(const char *format, ...);
void mfp_delay_ms(int d);
