/*
 * T030 ROM BIOS - Rudimentary system calls for newlib
 *
 * (c) 2016 Tobias Rathje <tobbe@fasanix.com>
 *
 */

#include <sys/types.h>
#include <sys/stat.h>
#include "mfp.h"

caddr_t sbrk(int incr)
{
	extern char _heap_start; /* Defined by the linker */
	static char *heap_end;
	char *prev_heap_end;

	if (heap_end == 0)
		heap_end = &_heap_start;

	prev_heap_end = heap_end;
	heap_end += incr;

	return (caddr_t) prev_heap_end;
}

int write(int file, char *ptr, int len)
{
	int todo;

	for (todo = 0; todo < len; todo++)
	{
		mfp_putc(*ptr++);
	}

	return len;
}

int close(int file)
{
	return -1;
}

int fstat(int file, struct stat *st)
{
	st->st_mode = S_IFCHR;
	return 0;
}

int isatty(int file)
{
	return 1;
}

int lseek(int file, int ptr, int dir)
{
	return 0;
}

int read(int file, char *ptr, int len)
{
	return 0;
}
