MEMORY
{
	rom (rx) :  ORIGIN = 0x00000000, LENGTH = 64K
    ram (rwx) : ORIGIN = 0x00080000, LENGTH = 64K
}

SECTIONS
{
    .  = 0x0;           /* From 0x00000000 */
    .text : 
    {
    	. = ALIGN(4);
        *(.init_vector)  /* Vector table */
        *(.text.*)
        *(.text)        /* Program code */
		*(.rodata.*)
		*(.rodata)
		. = ALIGN(4);
		
      	_rom_data = .;
    } > rom

    .  = 0x00080000;    /* From 0x00080000 */ 
    .vector :			/* Exception Vector Table */
    {
    	. = . + 1024;
    } > ram
    
    .data : AT (_rom_data)
    {
    	_data_start = .;
        . = ALIGN(4);
        *(.data)        /* Data memory */
        . = ALIGN(4);
        _data_end = .;
    } > ram

    .bss : 
   	{
   		_bss_start = .;
        . = ALIGN(4);
        *(.bss)         /* Zero-filled run time allocate data memory */
        . = ALIGN(4);
        _bss_end = .;
    } > ram
    
	.heap :
	{
    	_heap_start = .;
    } > ram 
}  