/*
 * T030 ROM BIOS - SPI routines for the TP3465 MID
 *
 * (c) 2016 Tobias Rathje <tobbe@fasanix.com>
 *
 */

#include "tp3465.h"
#include "util.h"

void tp3465_init()
{
	// all CS as output
	TP3465_PD = 0x0;

	// clk / 8
	TP3465_SKR = 0x83;
}

void tp3465_assert_cs(uint8_t addr)
{
	bit_clear(TP3465_CS, addr);
}

void tp3465_negate_cs(uint8_t addr)
{
	bit_set(TP3465_CS, addr);
}

void tp3465_write(uint8_t c)
{
	TP3465_FMB = c;

	while (bit_is_clear(TP3465_ST, 7));;
}

uint8_t tp3465_read()
{
	TP3465_FMB = 0xff;

	while (bit_is_clear(TP3465_ST, 7));;

	return TP3465_FMB;
}
