#include "util.h"

#define TP3465_BASE 0x180000

#define TP3465_SMB _MMIO_BYTE(TP3465_BASE + 0x0)	// second microwire byte register
#define TP3465_FMB _MMIO_BYTE(TP3465_BASE + 0x1)	// first microwire byte register
#define TP3465_FMBD0 _MMIO_BYTE(TP3465_BASE + 0x2)	// first microwire byte dev0 register
#define TP3465_FMBD1 _MMIO_BYTE(TP3465_BASE + 0x3)	// first microwire byte dev1 register
#define TP3465_FMBD2 _MMIO_BYTE(TP3465_BASE + 0x4)	// first microwire byte dev2 register
#define TP3465_FMBD3 _MMIO_BYTE(TP3465_BASE + 0x5)	// first microwire byte dev3 register
#define TP3465_FMBD4 _MMIO_BYTE(TP3465_BASE + 0x6)	// first microwire byte dev4 register
#define TP3465_FMBD5 _MMIO_BYTE(TP3465_BASE + 0x7)	// first microwire byte dev5 register
#define TP3465_FMBD6 _MMIO_BYTE(TP3465_BASE + 0x8)	// first microwire byte dev6 register
#define TP3465_FMBD7 _MMIO_BYTE(TP3465_BASE + 0x9)	// first microwire byte dev7 regiser
#define TP3465_CS _MMIO_BYTE(TP3465_BASE + 0xa)		// chip select register
#define TP3465_SKP _MMIO_BYTE(TP3465_BASE + 0xb)	// microwire clock polarity register
#define TP3465_MWM _MMIO_BYTE(TP3465_BASE + 0xc)	// microwire mode register
#define TP3465_SKR _MMIO_BYTE(TP3465_BASE + 0xd)	// microwire clock rate register
#define TP3465_ST _MMIO_BYTE(TP3465_BASE + 0xe)		// microwire status register
#define TP3465_PD _MMIO_BYTE(TP3465_BASE + 0xf)		// pin definition register

void tp3465_init();
void tp3465_assert_cs(uint8_t addr);
void tp3465_negate_cs(uint8_t addr);
void tp3465_write(uint8_t c);
uint8_t tp3465_read();
