#include <inttypes.h>

/*
 * MMIO macros borrowed from AVR sfr_defs.h
 */
#define _MMIO_BYTE(mem_addr) (*(volatile uint8_t *)(mem_addr))
#define _MMIO_WORD(mem_addr) (*(volatile uint16_t *)(mem_addr))
#define _MMIO_DWORD(mem_addr) (*(volatile uint32_t *)(mem_addr))

#define _SFR_MEM_ADDR(sfr) ((uint32_t) &(sfr))
#define _SFR_ADDR(sfr) _SFR_MEM_ADDR(sfr)
#define _SFR_BYTE(sfr) _MMIO_BYTE(_SFR_ADDR(sfr))

#define _BV(bit) (1 << (bit))

#define bit_is_set(sfr, bit) (_SFR_BYTE(sfr) & _BV(bit))
#define bit_is_clear(sfr, bit) (!(_SFR_BYTE(sfr) & _BV(bit)))

#define bit_set(sfr, bit) sfr |= _BV(bit)
#define bit_clear(sfr, bit) sfr &= ~(_BV(bit))

#ifndef NULL
#define	NULL		0
#endif

#ifndef	FALSE
#define FALSE		0
#define TRUE		!FALSE
#endif
